Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.http.impl.client
Class DefaultRequestDirector

    java.lang.Object
      org.apache.http.impl.client.DefaultRequestDirector

All Implemented Interfaces:
  RequestDirector

    @NotThreadSafe
    public class DefaultRequestDirector

extends Object
implements RequestDirector

Default implementation of `RequestDirector`.

The following parameters can be used to customize the behavior of this class:

- `CoreProtocolPNames.PROTOCOL_VERSION`
- `CoreProtocolPNames.STRICT_TRANSFER_ENCODING`
- `CoreProtocolPNames.HTTP_ELEMENT_CHARSET`
- `CoreProtocolPNames.USE_EXPECT_CONTINUE`
- `CoreProtocolPNames.WAIT_FOR_CONTINUE`
- `CoreProtocolPNames.USER_AGENT`
- `CoreConnectionPNames.SOCKET_BUFFER_SIZE`
- `CoreConnectionPNames.MAX_LINE_LENGTH`
- `CoreConnectionPNames.MAX_HEADER_COUNT`
- `CoreConnectionPNames.SO_TIMEOUT`
- `CoreConnectionPNames.SO_LINGER`
- `CoreConnectionPNames.SO_REUSEADDR`
- `CoreConnectionPNames.TCP_NODELAY`
- `CoreConnectionPNames.CONNECTION_TIMEOUT`
- `CoreConnectionPNames.STALE_CONNECTION_CHECK`
- `ConnRoutePNames.FORCED_ROUTE`
- `ConnRoutePNames.LOCAL_ADDRESS`
- `ConnRoutePNames.DEFAULT_PROXY`
- `CookieSpecPNames.DATE_PATTERNS`
- `CookieSpecPNames.SINGLE_COOKIE_HEADER`
- `AuthPNames.CREDENTIAL_CHARSET`
- `ClientPNames.COOKIE_POLICY`
- `ClientPNames.HANDLE_AUTHENTICATION`
- `ClientPNames.HANDLE_REDIRECTS`
- `ClientPNames.MAX_REDIRECTS`
- `ClientPNames.ALLOW_CIRCULAR_REDIRECTS`
- `ClientPNames.VIRTUAL_HOST`
- `ClientPNames.DEFAULT_HOST`
- `ClientPNames.DEFAULT_HEADERS`
- `ClientPNames.CONN_MANAGER_TIMEOUT`

Since:
  4.0

Field Summary
`protected ClientConnectionManager` | `connManager` The connection manager.
`protected HttpProcessor` | `httpProcessor` The HTTP protocol processor.
`protected ConnectionKeepAliveStrategy` | `keepAliveStrategy` The keep-alive duration strategy.
`protected ManagedClientConnection` | `managedConn` The currently allocated connection.
`protected HttpParams` | `params` The HTTP parameters.
`protected AuthenticationHandler` | `proxyAuthHandler` Deprecated.
`protected AuthState` | `proxyAuthState`
`protected AuthenticationStrategy` | `proxyAuthStrategy` The proxy authentication handler.
`protected RedirectHandler` | `redirectHandler` Deprecated.
`protected RedirectStrategy` | `redirectStrategy` The redirect strategy.
`protected HttpRequestExecutor` | `requestExec` The request executor.
`protected HttpRequestRetryHandler` | `retryHandler` The request retry handler.
`protected ConnectionReuseStrategy` | `reuseStrategy` The connection re-use strategy.
`protected HttpRoutePlanner` | `routePlanner` The route planner.
`protected AuthenticationHandler` | `targetAuthHandler` Deprecated.
`protected AuthState` | `targetAuthState`
`protected AuthenticationStrategy` | `targetAuthStrategy` The target authentication handler.
`protected UserTokenHandler` | `userTokenHandler` The user token handler.

Constructor Summary
`DefaultRequestDirector(HttpRequestExecutor requestExec, ClientConnectionManager conman, ConnectionReuseStrategy reustrat, ConnectionKeepAliveStrategy kastrat, HttpRoutePlanner rouplan, HttpProcessor httpProcessor, HttpRequestRetryHandler retryHandler, RedirectHandler redirectHandler, AuthenticationHandler targetAuthHandler, AuthenticationHandler proxyAuthHandler, UserTokenHandler userTokenHandler, HttpParams params)` Deprecated.
`DefaultRequestDirector(org.apache.commons.logging.Log log, HttpRequestExecutor requestExec, ClientConnectionManager conman, ConnectionReuseStrategy reustrat, ConnectionKeepAliveStrategy kastrat, HttpRoutePlanner rouplan, HttpProcessor httpProcessor, HttpRequestRetryHandler retryHandler, RedirectStrategy redirectStrategy, AuthenticationHandler targetAuthHandler, AuthenticationHandler proxyAuthHandler, UserTokenHandler userTokenHandler, HttpParams params)` Deprecated.
`DefaultRequestDirector(org.apache.commons.logging.Log log, HttpRequestExecutor requestExec, ClientConnectionManager conman, ConnectionReuseStrategy reustrat, ConnectionKeepAliveStrategy kastrat, HttpRoutePlanner rouplan, HttpProcessor httpProcessor, HttpRequestRetryHandler retryHandler, RedirectStrategy redirectStrategy, AuthenticationStrategy targetAuthStrategy, AuthenticationStrategy proxyAuthStrategy, UserTokenHandler userTokenHandler, HttpParams params)`

Method Summary
`protected HttpRequest` | `createConnectRequest(HttpRoute route, HttpContext context)` Creates the CONNECT request for tunnelling.
`protected boolean` | `createTunnelToProxy(HttpRoute route, int hop, HttpContext context)` Creates a tunnel to an intermediate proxy.
`protected boolean` | `createTunnelToTarget(HttpRoute route, HttpContext context)` Creates a tunnel to the target server.
`protected HttpRoute` | `determineRoute(HttpHost target, HttpRequest request, HttpContext context)` Determines the route for a request.
`protected void` | `establishRoute(HttpRoute route, HttpContext context)` Establishes the target route.
`HttpResponse` | `execute(HttpHost target, HttpRequest request, HttpContext context)` Executes a request.
`protected RoutedRequest` | `handleResponse(RoutedRequest roureq, HttpResponse response, HttpContext context)` Analyzes a response to check need for a followup.
`protected void` | `releaseConnection()` Returns the connection back to the connection manager and prepares for retrieving a new connection during the next request.
`protected void` | `rewriteRequestURI(RequestWrapper request, HttpRoute route)`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### connManager

    protected final ClientConnectionManager connManager

  The connection manager.

### routePlanner

    protected final HttpRoutePlanner routePlanner

  The route planner.

### reuseStrategy

    protected final ConnectionReuseStrategy reuseStrategy

  The connection re-use strategy.

### keepAliveStrategy

    protected final ConnectionKeepAliveStrategy keepAliveStrategy

  The keep-alive duration strategy.

### requestExec

    protected final HttpRequestExecutor requestExec

  The request executor.

### httpProcessor

    protected final HttpProcessor httpProcessor

  The HTTP protocol processor.

### retryHandler

    protected final HttpRequestRetryHandler retryHandler

  The request retry handler.

### redirectHandler

    @Deprecated
    protected final RedirectHandler redirectHandler

  Deprecated.
  The redirect handler.

### redirectStrategy

    protected final RedirectStrategy redirectStrategy

  The redirect strategy.

### targetAuthHandler

    @Deprecated
    protected final AuthenticationHandler targetAuthHandler

  Deprecated.
  The target authentication handler.

### targetAuthStrategy

    protected final AuthenticationStrategy targetAuthStrategy

  The target authentication handler.

### proxyAuthHandler

    @Deprecated
    protected final AuthenticationHandler proxyAuthHandler

  Deprecated.
  The proxy authentication handler.

### proxyAuthStrategy

    protected final AuthenticationStrategy proxyAuthStrategy

  The proxy authentication handler.

### userTokenHandler

    protected final UserTokenHandler userTokenHandler

  The user token handler.

### params

    protected final HttpParams params

  The HTTP parameters.

### managedConn

    protected ManagedClientConnection managedConn

  The currently allocated connection.

### targetAuthState

    protected final AuthState targetAuthState

### proxyAuthState

    protected final AuthState proxyAuthState

Constructor Detail

### DefaultRequestDirector

    @Deprecated
    public DefaultRequestDirector(HttpRequestExecutor requestExec,
                                             ClientConnectionManager conman,
                                             ConnectionReuseStrategy reustrat,
                                             ConnectionKeepAliveStrategy kastrat,
                                             HttpRoutePlanner rouplan,
                                             HttpProcessor httpProcessor,
                                             HttpRequestRetryHandler retryHandler,
                                             RedirectHandler redirectHandler,
                                             AuthenticationHandler targetAuthHandler,
                                             AuthenticationHandler proxyAuthHandler,
                                             UserTokenHandler userTokenHandler,
                                             HttpParams params)

  Deprecated.

### DefaultRequestDirector

    @Deprecated
    public DefaultRequestDirector(org.apache.commons.logging.Log log,
                                             HttpRequestExecutor requestExec,
                                             ClientConnectionManager conman,
                                             ConnectionReuseStrategy reustrat,
                                             ConnectionKeepAliveStrategy kastrat,
                                             HttpRoutePlanner rouplan,
                                             HttpProcessor httpProcessor,
                                             HttpRequestRetryHandler retryHandler,
                                             RedirectStrategy redirectStrategy,
                                             AuthenticationHandler targetAuthHandler,
                                             AuthenticationHandler proxyAuthHandler,
                                             UserTokenHandler userTokenHandler,
                                             HttpParams params)

  Deprecated.

### DefaultRequestDirector

    public DefaultRequestDirector(org.apache.commons.logging.Log log,
                                  HttpRequestExecutor requestExec,
                                  ClientConnectionManager conman,
                                  ConnectionReuseStrategy reustrat,
                                  ConnectionKeepAliveStrategy kastrat,
                                  HttpRoutePlanner rouplan,
                                  HttpProcessor httpProcessor,
                                  HttpRequestRetryHandler retryHandler,
                                  RedirectStrategy redirectStrategy,
                                  AuthenticationStrategy targetAuthStrategy,
                                  AuthenticationStrategy proxyAuthStrategy,
                                  UserTokenHandler userTokenHandler,
                                  HttpParams params)

Since:
  4.2

Method Detail

### rewriteRequestURI

    protected void rewriteRequestURI(RequestWrapper request,
                                     HttpRoute route)
                              throws ProtocolException

  Throws:
    `ProtocolException`

### execute

    public HttpResponse execute(HttpHost target,
                                HttpRequest request,
                                HttpContext context)
                         throws HttpException,
                                IOException

  Description copied from interface: `RequestDirector`
  Executes a request.
  Note: For the time being, a new director is instantiated for each request. This is the same behavior as for `HttpMethodDirector` in HttpClient 3.

  Specified by:
    `execute` in interface `RequestDirector`
  Parameters:
    `target` - the target host for the request. Implementations may accept `null` if they can still determine a route, for example to a default target or by inspecting the request.
    `request` - the request to execute
    `context` - the context for executing the request
  Returns:
    the final response to the request. This is never an intermediate response with status code 1xx.
  Throws:
    `HttpException` - in case of a problem
    `IOException` - in case of an IO problem or if the connection was aborted

### releaseConnection

    protected void releaseConnection()

  Returns the connection back to the connection manager and prepares for retrieving a new connection during the next request.

### determineRoute

    protected HttpRoute determineRoute(HttpHost target,
                                       HttpRequest request,
                                       HttpContext context)
                                throws HttpException

  Determines the route for a request. Called by `execute(org.apache.http.HttpHost, org.apache.http.HttpRequest, org.apache.http.protocol.HttpContext)` to determine the route for either the original or a followup request.

  Parameters:
    `target` - the target host for the request. Implementations may accept `null` if they can still determine a route, for example to a default target or by inspecting the request.
    `request` - the request to execute
    `context` - the context to use for the execution, never `null`
  Returns:
    the route the request should take
  Throws:
    `HttpException` - in case of a problem

### establishRoute

    protected void establishRoute(HttpRoute route,
                                  HttpContext context)
                           throws HttpException,
                                  IOException

  Establishes the target route.

  Parameters:
    `route` - the route to establish
    `context` - the context for the request execution
  Throws:
    `HttpException` - in case of a problem
    `IOException` - in case of an IO problem

### createTunnelToTarget

    protected boolean createTunnelToTarget(HttpRoute route,
                                           HttpContext context)
                                    throws HttpException,
                                           IOException

  Creates a tunnel to the target server. The connection must be established to the (last) proxy. A CONNECT request for tunnelling through the proxy will be created and sent, the response received and checked. This method does not update the connection with information about the tunnel, that is left to the caller.

  Parameters:
    `route` - the route to establish
    `context` - the context for request execution
  Returns:
    `true` if the tunnelled route is secure, `false` otherwise. The implementation here always returns `false`, but derived classes may override.
  Throws:
    `HttpException` - in case of a problem
    `IOException` - in case of an IO problem

### createTunnelToProxy

    protected boolean createTunnelToProxy(HttpRoute route,
                                          int hop,
                                          HttpContext context)
                                   throws HttpException,
                                          IOException

  Creates a tunnel to an intermediate proxy. This method is not implemented in this class. It just throws an exception here.

  Parameters:
    `route` - the route to establish
    `hop` - the hop in the route to establish now. `route.getHopTarget(hop)` will return the proxy to tunnel to.
    `context` - the context for request execution
  Returns:
    `true` if the partially tunnelled connection is secure, `false` otherwise.
  Throws:
    `HttpException` - in case of a problem
    `IOException` - in case of an IO problem

### createConnectRequest

    protected HttpRequest createConnectRequest(HttpRoute route,
                                               HttpContext context)

  Creates the CONNECT request for tunnelling. Called by `createTunnelToTarget`.

  Parameters:
    `route` - the route to establish
    `context` - the context for request execution
  Returns:
    the CONNECT request for tunnelling

### handleResponse

    protected RoutedRequest handleResponse(RoutedRequest roureq,
                                           HttpResponse response,
                                           HttpContext context)
                                    throws HttpException,
                                           IOException

  Analyzes a response to check need for a followup.

  Parameters:
    `roureq` - the request and route.
    `response` - the response to analayze
    `context` - the context used for the current request execution
  Returns:
    the followup request and route if there is a followup, or `null` if the response should be returned as is
  Throws:
    `HttpException` - in case of a problem
    `IOException` - in case of an IO problem

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 1999-2013 The Apache Software Foundation. All Rights Reserved.